<?php
 
define ('_JEXEC', true);
define ('JPATH_SITE',$_SERVER ['DOCUMENT_ROOT']);

if (!defined ('_JDEFINES')) 
{
	define ('JPATH_BASE', JPATH_SITE);

	require_once JPATH_BASE . '/includes/defines.php';    
}

if (file_exists (JPATH_SITE . '/includes/defines.php')) 
{
	include_once JPATH_SITE . '/includes/defines.php';
}

require_once JPATH_BASE . '/includes/framework.php';
 
$app = \JFactory::getApplication ('site');

chdir ('../../../components/com_jshopping/shippings/sm_baikalsr_shipping/classes/');

require_once ('baikalsr_client.php');

$allowed_methods = [
	'getSettings',     'saveSettings',   'getAffiliateData', 'saveShippingDetails',
	'getCityByName',   'getCityByGuid',  'getStreetsByName', 'getStreetByGuid',
	'getHousesByName', 'getHouseByGuid', 'getCargoTypes',    'getServices',
	'getPartnerTypes', 'getContragents', 'sumSizeOneGoods',  'sumSize',
	'calculateOrder',  'createOrder',    'getOrderData',     'getTrackingData',
	'saveShippingMethod'
];

$check_token_for_these = [
	'getSettings', 'saveSettings', 'getContragents', 'createOrder'
];

$secret = JFactory::getConfig() ['secret'];
$token  = hash_hmac ('sha256', $secret, $secret);

$method = $_GET ['method'];

if (!in_array ($method, $allowed_methods)) {
	exit ();
}

if (in_array ($method, $check_token_for_these) && $_GET ['token'] != $token) {
	exit ();
}

$args   = json_decode ($_GET ['args'] ?? "{}", true);

$client = new BaikalsrClient ();

echo json_encode (
    call_user_func_array (array ($client, $method), $args)
);
