<?php

defined ('_JEXEC') or die ();

use Joomla\CMS\Application;
use Joomla\CMS\Application\ApplicationHelper;
use Joomla\Registry\Registry;

class plgJshoppingOrderBaikalsr_shipping extends JPlugin 
{
    public $shipping_method_id = -1;
    public $sh_pr_method_id = -1;
    
    public $tmp_html_start = <<<END
    
        <link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css" rel="stylesheet" />
        <script src="/plugins/jshoppingorder/baikalsr_shipping/js/select2.min.js"></script>

        <link href="/plugins/jshoppingorder/baikalsr_shipping/css/common.css" rel="stylesheet" />
        <script src="/plugins/jshoppingorder/baikalsr_shipping/js/common.js"></script>

        <script src="http://localhost/components/com_jshopping/js/jquery/jquery.media.js"></script>
        <script src="https://code.jquery.com/ui/1.13.2/jquery-ui.js"></script>
        <script src="https://cdn.jsdelivr.net/npm/jquery.maskedinput@1.4.1/src/jquery.maskedinput.min.js"></script>
        <script src=" https://cdn.jsdelivr.net/npm/jquery.numeric@1.0.0/jquery.numeric.min.js "></script>

        <link rel="stylesheet" href="//code.jquery.com/ui/1.13.2/themes/base/jquery-ui.css">

END;

    public function __construct (&$subject, $config = array ())
    {
        $db = JFactory::getDbo();

        $query = $db->getQuery (true);
        $query->select (array ('shipping_id', 'sh_pr_method_id'))
            ->from ($db->quoteName ("#__jshopping_shipping_method") . ' sm')
            ->leftJoin ($db->quoteName ('#__jshopping_shipping_method_price') . 'p ON p.shipping_method_id = sm.shipping_id')
            ->where ("alias = 'baikalsr_shipping'");
        
        $db->setQuery ($query);    
        
        $result = $db->loadAssoc();

        $this->shipping_method_id = $result ['shipping_id'];
        $this->sh_pr_method_id    = $result ['sh_pr_method_id'];

        $_SESSION ['baikalsr__shipping_method_id'] = $this->shipping_method_id;
        $_SESSION ['baikalsr__sh_pr_method_id'] = $this->sh_pr_method_id;

        parent::__construct ($subject, $config);
    }

    public function onLoadCheckoutStep2 ()
    {
        if (isset ($_SESSION ['baikalsr__shipping_data']))
        {
            unset ($_SESSION ['baikalsr__shipping_data']);
        }
    }
    
    public function onBeforeDisplayCheckoutStep4View (&$view)
    { 
        $session    = JFactory::getSession();
        $rows       = $session->get ('shipping_price');
        $cartData   = $session->get ('cartData');

        if (isset ($_SESSION ['baikalsr__active_shipping']))
        {
            $view->active_shipping = $_SESSION ['baikalsr__active_shipping'];
        }

        $shippingData = $_SESSION ['baikalsr__shipping_data'];

        require_once ('order_form.php');
    }

    public function onBeforeDisplayCheckoutStep5 (&$sh_method, &$pm_method, &$delivery_info, &$cart, &$view)
    {
        if ($sh_method->shipping_id == $this->shipping_method_id)
        {
            $shipping_data = $_SESSION ['baikalsr__shipping_data'];

            $delivery_info ['city'] = $shipping_data ['city-text'];

            if (!$shipping_data ['is_terminal'])
            {
                $delivery_info ['street'] = $shipping_data ['street-text'];
                $delivery_info ['home']   = $shipping_data ['house-text'];
            }
            else
            {
                $delivery_info ['home']   = '';
                $delivery_info ['street'] = 'Терминал ' . $shipping_data ['terminal-text'];
            }
        }
    }

    public function onEndCheckoutStep5 (&$order, &$cart)
    {
        if ($order->shipping_method_id == $this->shipping_method_id)
        {
            $db = JFactory::getDbo ();
            
            $obj = new stdClass ();

            $obj->order_id   = $order->order_id;
            $obj->order_data = json_encode ($_SESSION ['baikalsr__shipping_data']);

            $db->insertObject ('#__jshopping_baikalsr_orders', $obj);

            unset ($_SESSION ['baikalsr__shipping_data']);
        }
    }
    public static function buildOrder ($order)
    {
        $data = [
            'order_id'              => $order->order_id,
            'shipping_method_id'    => $order->shipping_method_id,
            'payment_id'            => $order->payment_method_id,
            'price_product_brutto'  => $order->order_total,
            'order_shipping_cost'   => $order->order_shipping,
            'person_type'           => 0,
            'deliveryCity'          => $order->d_city,
            'deliveryState'         => $order->d_state,
            'deliveryAddress'       => $order->d_zip . ', ' . $order->d_state . ', ' . $order->d_city . ', ' . $order->d_street,

            'person' => [ 
                'first_name'    => $order->d_f_name,
				//'last_name'     => $order->d_m_name,
                'last_name'     => $order->d_l_name,
                'country_id'    => $order->d_country,
                'email'         => $order->d_email,
                'state'         => $order->d_state,
                'city'          => $order->d_city,
                'address'       => $order->d_street,
                'comment'       => $order->order_add_info,
                'phone'         => $order->d_phone,
                'zip'           => $order->d_zip,
                'full_address'  => $order->d_zip . ', ' . $order->d_state . ', ' . $order->d_city . ', ' . $order->d_street
            ],

            'products' => self::buildProductsForOrder (
                $order->getAllItems ()
            )
        ];

        return (object) $data;
    }

    public static function buildProductsForOrder ($products)
    {
        $_products = [];
        
        foreach ($products as $product)
        {
            $_paramsList = [
                'product_id'    => $product->product_id,
                'quantity'      => $product->product_quantity,
                'category_id'   => $product->category_id,
                'product_name'  => $product->product_name,
                'weight'        => $product->weight,
                'product_data'  => $product,
                'extra_fields'  => self::getExtraFields ($product->product_id)
            ];

            $_products [] = $_paramsList;
        }

        return $_products;
    }

    public static function getExtraFieldInProduct ($product_id, $field_id)
    {
        $db = JFactory::getDBO ();
        $q  = 'SELECT * FROM `#__jshopping_products` WHERE `product_id` = ' . $product_id;

        $db->setQuery ($q);

        $rows  = $db->loadObjectList ();
        $value = (array) $rows [0];

        return $value ["extra_field_" . $field_id];
    }

    public static function getExtraFields ($product_id)
    {
        $listfield = JSFactory::getAllProductExtraField ();
        $extra_fields = [];

        foreach ($listfield as $item)
        {
            $extra_fields[] = [
                'id'            => $item->id,
                'name'          => $item->name,
                'description'   => $item->description,
                'value'         => self::getExtraFieldInProduct ($product_id, $item->id),
                'groupname'     => $item->groupname
            ];

        }

        return $extra_fields;
    }

    private function getTrackId ($order_id)
    {
        $db = JFactory::getDbo();

        $query = $db->getQuery (true);
        
        $query->select (array ('request_id'))
              ->from ($db->quoteName ("#__jshopping_baikalsr_orders"))
              ->where ("order_id = " . $db->quote ($order_id)) ;

        $db->setQuery ($query);    

        return $db->loadResult ();
    }

    public function onBeforeShowOrder (&$view) 
    {
        if ($view->order->shipping_method_id == $this->shipping_method_id)
        {
            $track_id = $this->getTrackId ($view->order->order_id);

            ob_start ();
            
            $secret = JFactory::getConfig() ['secret'];
            $token  = hash_hmac ('sha256', $secret, $secret);
            
            require_once ('order.php');
            
            $order_html = ob_get_contents ();
            ob_end_clean ();
    
            $view->tmp_html_start = $this->tmp_html_start;
            $view->tmp_html_info = $order_html;
        }
    }

    public function onBeforeDisplayOrderView (&$view)
    {
        if ($view->order->shipping_method_id == $this->shipping_method_id)
        {
            $track_id = $this->getTrackId ($view->order->order_id);
            
            ob_start ();

            require_once ('delivery_status.php');
            
            $html = ob_get_contents ();
            ob_end_clean ();
            
            $view->_tmp_html_start = $this->tmp_html_start;
            $view->_tmp_html_after_total = $html;
        }
    }
}

