
var decodeHTMLEntities = function (str) {
    
    var div = document.createElement("div");
    div.innerHTML = str;
    var text = div.textContent || div.innerText || "";
    
    var div = document.createElement("div");
    div.innerHTML = text;
    var text = div.textContent || div.innerText || "";
    
    return text;
}

jQuery.fn.preBind = function(type, data, fn) {
    this.each(function () {
        var $this = jQuery(this);

        $this.bind(type, data, fn);

        var currentBindings = $this.data('events')[type];
        if (jQuery.isArray(currentBindings)) {
            currentBindings.unshift(currentBindings.pop());
        }
    });
    return this;
};

var testApiConnection = function () {
    var result;

    jQuery.ajax ({
        url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=getPartnerTypes',
        async: false,
        dataType: 'json'
    }).done (function (data) {
        result = data;
    });

    return (result.length > 0);
}

var initAddressBoxes = function () {
	
    jQuery ('.baikalsr-ajax-city').select2 ({
        ajax: {
            url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=getCityByName',
            dataType: 'json',  
            data: (params) => {
                return {
                    args: JSON.stringify ({ "city": params.term }),
                }
            },
            processResults: (data, params) => {
                return { results: data.map (item => { return { id: item.guid, text: item.name }; }) }
            },
        }
    });

    jQuery ('.baikalsr-ajax-city').change (function () {
		jQuery ('.baikalsr-ajax-city').closest('.control-group').removeClass('error');
        jQuery ('.baikalsr-ajax-street').empty ().trigger ('change');
        jQuery ('.baikalsr-ajax-terminal').empty ();
        initTerminalBox (jQuery ('.baikalsr-ajax-city').val ());
    });
    
    jQuery ('.baikalsr-ajax-street').select2 ({
        ajax: {
            url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=getStreetsByName',
            dataType: 'json', 
            data: (params) => {
                return {
                    args: JSON.stringify ({ 
                        "cityGuid": jQuery (".baikalsr-ajax-city").val (),
                        "street": params.term 
                    }),
                }
            },  
            processResults: (data, params) => {
                return { results: data.map (item => { return { id: item.guid, text: item.title }; }) }
            },
        }
    });
    
    jQuery ('.baikalsr-ajax-street').change (function () {
		jQuery ('.baikalsr-ajax-street').closest('.control-group').removeClass('error');		
        jQuery ('.baikalsr-ajax-house').empty ().trigger ('change');
		jQuery ('.baikalsr-housing').val ('');
        jQuery ('.baikalsr-building').val ('');
        jQuery ('.baikalsr-apt').val ('');
    });
    
    jQuery ('.baikalsr-ajax-house').select2 ({
        ajax: {
            url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=getHousesByName',
            dataType: 'json',  
            data: (params) => {
                return {
                    args: JSON.stringify ({ 
                        "streetGuid": jQuery (".baikalsr-ajax-street").val (),
                        "house": params.term 
                    }),
                }
            },  
            processResults: (data, params) => {
                return { results: data.map (item => { 
                    var house_id = jQuery (".baikalsr-ajax-street").val () + "|"
                        + item.housenum + "|" + item.buildnum + "|" + item.strucnum ;

                    return { id: house_id, text: item.formatted }; 
                }) }
            },
        }
    });

    jQuery ('.baikalsr-ajax-house').on ('select2:select', function (e) {
		jQuery ('.baikalsr-ajax-house').closest('div[class="control-group"]').removeClass('error');
        loadHouseFields ();
    })
};

var loadHouseFields = function (housing = null, building = null) {
    var house = jQuery ('.baikalsr-ajax-house').val ();
    var refreshHouseText = false;

    if (house !== null)
    {
        house = house.split ('|');
		
        if (house.length)
        {
            jQuery ('.baikalsr-housing').val  (housing  ? housing  : house [2]);
            jQuery ('.baikalsr-building').val (building ? building : house [3]);
            jQuery ('.baikalsr-apt').val ('');
            refreshHouseText = true;
        }
    }

    setTimeout (function () {

        if (refreshHouseText)
        {
            jQuery ('.baikalsr-ajax-house').next ().find ('.select2-selection__rendered').text (house [1])
        }
    }, 500); 
}

var initTerminalBox = function (cityGuid, terminal) {
    var noTerminals = false;
    var e = jQuery ('.baikalsr-ajax-terminal');
    jQuery.ajax ({
        url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=getAffiliateData&args={"guid":"' + cityGuid + '"}',
        async: false,
    }).done (function (data) {
        data = JSON.parse(data);
        if (!Object.keys (data).length) {
            noTerminals = true;
            e.append (jQuery ('<option>', {
                value: -1,
                text:  '(В выбранном городе нет терминалов)'
            }));
        } else if (data.terminals !== undefined) {
            data.terminals.map (item => { 
                
                if ((typeof (terminal_start_only)  !== 'undefined' && item.start) ||
                    (typeof (terminal_finish_only) !== 'undefined' && item.finish))
                {
                    e.append (jQuery ('<option>', {
                        value: item.code,
                        text:  item.name + ' (' + decodeHTMLEntities(item.address) + ')'
                    }));
                }
            });
			if(terminal)
				e.val (terminal);
			else
				e.prop("selectedIndex", 0);
        };
    });
    return !noTerminals;
}

var initPartnerTypeBox = function (val) {
    var e = jQuery ('.baikalsr-ajax-opf');
    jQuery.ajax ({
        url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=getPartnerTypes',
        dataType: 'json',
        async: false
    }).done (function (data) {
        data.map (item => {  
            e.append (jQuery ('<option>', {
                value: item.legalForm + '_' + item.id,
                text: item.legalFormName + ' (' + item.name + ')'
            }));
        });
        e.val (val);
    });
}

var initContragentsBox = function (val, token) {
    var e = jQuery ('.baikalsr-ajax-contragent');

    /*
    e.append (jQuery ('<option>', {
        value: "",
        text: "Не указан"
    }));
    */

    jQuery.ajax ({
        url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=getContragents&token=' + token,
        dataType: 'json',
        async: false
    }).done (function (data) {
        data.map (item => {  
            e.append (jQuery ('<option>', {
                value: item.guid,
                text: item.name
            }));
        });
        e.val (val);
    });
}

const syncWait = ms => {
    const end = Date.now() + ms
    while (Date.now() < end) continue
}

var initCargoTypeBox = function (val) {
    var e = jQuery ('.baikalsr-ajax-cargo-type');
    jQuery.ajax ({
        url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=getCargoTypes',
        dataType: 'json'
    }).done (function (data) {
        data.map (item => {  
            e.append (jQuery ('<option>', {
                value: item.id,
                text: item.name
            }));
        });
        e.val (val);
    });
}

var loadCity = function (cityGuid) {
    var city = JSON.parse (
        jQuery.ajax ({
            url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=getCityByGuid&args={"guid":"'  + cityGuid + '"}',
            async: false
        }).responseText
    );

    jQuery ('.baikalsr-ajax-city').append (
        jQuery ('<option>', {
            value: city [0].guid,
            text:  city [0].name
        })
    );
}

var loadAddress = function (cityGuid, streetGuid, houseGuid, housing = null, building = null) {

    loadCity (cityGuid);

    if (streetGuid.length) {
        /* Get Street By GUID */

        var street = JSON.parse (
            jQuery.ajax ({
                url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=getStreetByGuid&args={"guid":"'  + streetGuid + '"}',
                async: false
            }).responseText
        );

        jQuery ('.baikalsr-ajax-street').append (
            jQuery ('<option>', {
                value: street [0].guid,
                text:  street [0].name
            })
        );

        if (houseGuid.length) {
            /* Get House */

            var house = JSON.parse (
                jQuery.ajax ({
                    url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=getHouseByGuid&args={"house_id":"'  + houseGuid + '"}',
                    async: false
                }).responseText
            ) [0];

            jQuery ('.baikalsr-ajax-house').append (
                jQuery ('<option>', {
                    value: street [0].guid + "|" + house.housenum + "|" + house.buildnum + "|" + house.strucnum,
                    text:  house.formatted
                })
            );
        
            loadHouseFields (housing, building);
        }
    }
}



var fillSettingsBoxes = function (settings) {
    jQuery ("#test-mode").prop ("checked", parseInt (settings.TestMode));
    jQuery ("#test-api-key").val (settings.ApiTestKey);
    jQuery ("#api-key").val (settings.ApiKey);
    jQuery ("#is-terminal").prop ("checked", parseInt (settings.IsTerminal));
    jQuery ("#baikalsr-ajax-prr").prop ("checked", parseInt (settings.DefaultPRR));
    jQuery ("#baikalsr-ajax-elevator").prop ("checked", parseInt (settings.DefaultElevator));
    jQuery ("#baikalsr-floor").val (settings.DefaultFloor);
    jQuery ("#company-name").val (settings.CompanyName);
    jQuery ("#contact-person").val (settings.ContactPerson);
    jQuery ("#phone").val (settings.Phone).mask ("+9 (999) 999-9999");
    jQuery ("#email").val (settings.Email);
    jQuery ("#inn").val (settings.INN);
    jQuery ("#kpp").val (settings.KPP);
    jQuery ("#addr-note").val (settings.AddressNote);
    jQuery ("#cargo-calc-type").val (settings.CargoCalcType);

    jQuery ("#author-first-name").val (settings.AuthorFirstName);
    jQuery ("#author-last-name").val (settings.AuthorLastName);
    jQuery ("#author-middle-name").val (settings.AuthorMiddleName);
    jQuery ("#author-email").val (settings.AuthorEmail);
    jQuery ("#author-phone").val (settings.AuthorPhone).mask ("+9 (999) 999-9999");
    jQuery ("#author-comment").val (settings.AuthorComment);
    
    loadAddress (
        settings.SenderCity,
        settings.SenderStreet,
        settings.SenderHouse,
        settings.SenderHousing,
        settings.SenderBuilding
    );

    jQuery ('.baikalsr-apt').val (settings.SenderApartment);

    initTerminalBox (settings.SenderCity, settings.SenderTerminal);

    initCargoTypeBox(settings.DefaultCargoType);
    
    jQuery ("#default-length").val (settings.DefaultCargoLength);
    jQuery ("#default-width").val  (settings.DefaultCargoWidth);
    jQuery ("#default-height").val (settings.DefaultCargoHeight);
    jQuery ("#default-weight").val (settings.DefaultCargoWeight);
    jQuery ("#additional-services").val (JSON.parse (settings.AdditionalServices));
    
    jQuery ("#small-bag-count").val (parseInt (settings.SmallBagCount));
    jQuery ("#middle-bag-count").val (parseInt (settings.MiddleBagCount));

    jQuery ("#cargo-default-settings-type").val (settings.CargoDefaultSettingsType);

    jQuery ("#detailed-info").prop ("checked", parseInt (settings.DetailedInfo));
    //5000D5B2-BC56-1000-11E1-8AD156EEC59D
}

var gatherAPISettings = function () {
    return {
        "TestMode":     parseInt (jQuery ("#test-mode").prop ("checked") | 0),
        "ApiKey":       jQuery ("#api-key").val (),
        "ApiTestKey":   jQuery ("#test-api-key").val ()
    };
}

var gatherSettings = function () {
    return {
        "IsTerminal":   parseInt (jQuery ("#is-terminal").prop ("checked") | 0),
        "DefaultPRR":   parseInt (jQuery ("#baikalsr-ajax-prr").prop ("checked") | 0),
        "DefaultFloor":     jQuery ("#baikalsr-floor").val (),
        "DefaultElevator":  parseInt (jQuery ("#baikalsr-ajax-elevator").prop ("checked") | 0),
        "SenderTerminal":   jQuery (".baikalsr-ajax-terminal").val (),
        "SenderCity":       jQuery (".baikalsr-ajax-city").val (),
        "SenderStreet":     jQuery (".baikalsr-ajax-street").val (),
        "SenderHouse":      jQuery (".baikalsr-ajax-house").val (),
        "SenderHousing":    jQuery (".baikalsr-housing").val (),
        "SenderBuilding":   jQuery (".baikalsr-building").val (),
        "SenderApartment":  jQuery (".baikalsr-apt").val (),
        "DefaultCargoType": jQuery (".baikalsr-ajax-cargo-type").val (),
        "DefaultCargoLength":   jQuery ("#default-length").val (),
        "DefaultCargoWidth":    jQuery ("#default-width").val (),
        "DefaultCargoHeight":   jQuery ("#default-height").val (),
        "DefaultCargoWeight":   jQuery ("#default-weight").val (),
        "AdditionalServices":   JSON.stringify (jQuery ("#additional-services").val ()),
        "SmallBagCount":    jQuery ("#small-bag-count").val (),
        "MiddleBagCount":   jQuery ("#middle-bag-count").val (),
        "OPF":              jQuery ("#opf").val(),
        "CompanyName":      jQuery ("#company-name").val (),
        "ContactPerson":    jQuery ("#contact-person").val (),
        "Phone":            jQuery ("#phone").val (),
        "Email":            jQuery ("#email").val (),
        "INN":              jQuery ("#inn").val (),
        "KPP":              jQuery ("#kpp").val (),
        "AddressNote":      jQuery ("#address-note").val (),
        "ContragentGuid":   jQuery ("#contragent").val (),
        "CargoCalcType":    jQuery ("#cargo-calc-type").val (),
        "AuthorFirstName":      jQuery ("#author-first-name").val (),
        "AuthorLastName":       jQuery ("#author-last-name").val (),
        "AuthorMiddleName":     jQuery ("#author-middle-name").val (),
        "AuthorPhone":          jQuery ("#author-phone").val (),
        "AuthorEmail":          jQuery ("#author-email").val (),
        "AuthorComment":        jQuery ("#author-comment").val (),
        "CargoDefaultSettingsType": jQuery ("#cargo-default-settings-type").val (),
        "DetailedInfo":  parseInt (jQuery ("#detailed-info").prop ("checked") | 0)
    };
}

var ajaxGetSettings = function (token) {
    return JSON.parse (
        jQuery.ajax ({
            url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=getSettings&token=' + token,
            async: false
        }).responseText
    );
}

var ajaxSumProductSizes = function (sizeArray) {
    return JSON.parse (
        jQuery.ajax ({
            url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=sumSize&args=' + JSON.stringify (
                { "a": sizeArray }
            ),
            async: false
        }).responseText
    );
}

var ajaxSumProductSizes2 = function (x, y, z, qty) {
    return JSON.parse (
        jQuery.ajax ({
            url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=sumSizeOneGoods&args=' + JSON.stringify (
                { "xi": x, "yi": y, "zi": z, "qty": qty }
            ),
            async: false
        }).responseText
    );
}

var ajaxSaveAPIKey = function (token) {
    jQuery.ajax ({
        url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=saveSettings&args=' + JSON.stringify (
            { "settings": gatherAPISettings () }
        ) + "&token=" + token,
        async: false
    });
    return true;
}

var ajaxSaveSettings = function (token) {
    jQuery.ajax ({
        url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=saveSettings&args=' + JSON.stringify (
            { "settings": gatherSettings () }
        ) + "&token=" + token,
        async: false
    });
    alert ('Изменения сохранены');
    return true;
}

var createShippingDetailsSummary = function (rows) {
    var summary = jQuery ('<div>').prop ("class", "shipping-summary");

    summary.append (rows ['departure']['title']  + ' &rarr; ' + rows ['destination']['title'] 
        + ' (' + rows ['cargo']['description']);

    if (parseInt (rows ['cargo']['oversized'])) {
        summary.append (' <i>Негабаритный</i>');
    }

    summary.append (')'); 

    return summary;
}

var createShippingDetailsTable = function (rows) {
    var details = jQuery ('<table>').prop ("class", "shipping-details");

    var details_row = function (service) {
        var row = jQuery ('<tr>');
        var col = jQuery ('<td>').attr ('colspan', '2');
        col.append (service ['name']);
        row.append (col);

        col = jQuery ('<td>');
        col.append (service ['cost'] ? service ['cost'] + ' р.' : '<i>Рассчитывается индивидуально</i>');
        row.append (col);
    
        details.append (row);
    }

    rows ['departure']['services']  .forEach (details_row);
    rows ['destination']['services'].forEach (details_row);
    rows ['cargo']['services']      .forEach (details_row);

    return details;
}

var loadDeliveryStatusText = function (track_id) {
    var args = { "track_id": track_id };
    var response = JSON.parse (
        jQuery.ajax ({
            url: '/plugins/jshoppingorder/baikalsr_shipping/ajax.php?method=getTrackingData&args=' + JSON.stringify (args),
            async: false
        }).responseText
    );
    jQuery (".baikalsr_status_text").html (
        typeof (response.status) != "undefined" 
            ? response.status.text
            : "Нет информации о статусе доставки"
    );
}