<?php

defined('_JEXEC') or die('Restricted access');

require_once (__DIR__ . '/classes/baikalsr_client.php');

class sm_baikalsr_shipping extends shippingextRoot 
{    
    const API_KEY = "";
    
    var $version = 1;
 
    public $shipping_method_id = -1;

    public function __construct ()
    {
        $db = JFactory::getDbo();

        $query = $db->getQuery (true);
        $query->select (array ('shipping_id'))->from ($db->quoteName ("#__jshopping_shipping_method"))->where ("alias = 'baikalsr_shipping'");
        
        $db->setQuery ($query);    
        $this->shipping_method_id = $db->loadResult ();

        $_SESSION ['baikalsr__shipping_method_id'] = $this->shipping_method_id;
    }

    public function showShippingPriceForm ($params, &$shipping_ext_row, &$template)
    {
        $secret = JFactory::getConfig() ['secret'];
        $token  = hash_hmac ('sha256', $secret, $secret);
        
        if ($template->sh_method_price->shipping_method_id == $this->shipping_method_id)
        {
            require_once (__DIR__ . '/templates/price_form.php');
        }
    }
    
    public function showConfigForm ($config, &$shipping_ext, &$template) {}
    
    public function getPrices ($cart, $params, $prices, &$shipping_ext_row, &$shipping_method_price)
    { 
        $weight_sum = $cart->getWeightProducts();
        $sh_price = $shipping_method_price->getPrices("desc");
        foreach($sh_price as $sh_pr){
            if ($weight_sum >= $sh_pr->shipping_weight_from && ($weight_sum <= $sh_pr->shipping_weight_to || $sh_pr->shipping_weight_to==0)) {
                $prices['shipping'] = $sh_pr->shipping_price;
                $prices['package'] = $sh_pr->shipping_package_price;
                break;
            }
        }
        return $prices;
    }


    private function getExtraFields ()
    {
        $db = JFactory::getDbo();

        $query = $db->getQuery (true);
        $query->select (array ('*'))->from ($db->quoteName ("#__jshopping_products_extra_fields"));

        $db->setQuery ($query);

        $rows = $db->loadAssocList();

        $result = [];

        foreach ($rows as $row)
        {
            $names = [];

            foreach ($row as $column_key => $column_val)
            {
                if (strpos ($column_key, "name_en") !== false)
                {
                    $names [] = $column_val;
                }
            }

            $result [$row ["id"]] = implode ("-", $names);
        }
        
        return $result;
    }

    private function getExtraFieldsByProduct ()
    {
        $db = JFactory::getDbo();

        $query = $db->getQuery (true);
        $query->select (array ('*'))->from ($db->quoteName ("#__jshopping_products"));

        $db->setQuery ($query);

        $rows = $db->loadAssocList();

        $extra_fields = $this->getExtraFields();

        $extra_fields_by_product = [];

        foreach ($rows as $row)
        {
            $id = $row ['product_id'];

            $fields = [];

            foreach ($row as $column_key => $column_val)
            {
                if (strpos ($column_key, "extra_field_") !== false)
                {
                    list ($tmp, $field_id) = explode ("_field_", $column_key);

                    $fields [$extra_fields [$field_id]] = $column_val;
                }
            }

            $extra_fields_by_product [$id] = $fields;
        }
        
        return $extra_fields_by_product;
    }

    private function cartData ()
    {
        $db   = JFactory::getDbo();
        $user = JFactory::getUser();

        $data = JFactory::getSession ()->getData()->jsonSerialize();

        $cart = unserialize ($data->__default->cart);
        
        if ($user->id)
        {
            $query = $db->getQuery (true);
            $query->select (array ('*'))->from ($db->quoteName ("#__jshopping_users"))->where ("user_id = {$user->id}");
    
            $db->setQuery ($query);    
            $columns = $db->loadAssoc();
            
            $city = $columns ['city'];
        }
        else
        {
            $user_shop_guest = unserialize ($data->__default->user_shop_guest);
    
            $city = $user_shop_guest ['city'];    
        }

        $extra_fields_by_product = $this->getExtraFieldsByProduct();
 
        $cargo_list = [];
  
        foreach ($cart->products as $id => $columns)
        {
            $ExtraFields = $extra_fields_by_product [$columns ["product_id"]];

			$Length = $ExtraFields ["Length"] ?? 0; 
            $Width  = $ExtraFields ["Width"]  ?? 0;  
            $Height = $ExtraFields ["Height"] ?? 0;

            $Volume = (float) $Length * (float) $Width * (float) $Height;
            
            $Weight = $columns ["weight"];

            $item = [
                "Length" => $Length,
                "Width"  => $Width,
                "Height" => $Height,
                "Volume" => $Volume,
                "Weight" => $Weight,
                "Units"  => $columns ["quantity"],
                "EstimatedCost" => $columns ["price"] * $columns ["quantity"], 
            ];            
            
            $cargo_list [] = $item; 
        } 

        return [
            'city' => $city,
            'cargo_list' => $cargo_list
        ];
    }
    
    public function getPrice ($cart, $params, $price, &$shipping_ext_row, &$shipping_method_price)
    {
		
        if ($shipping_method_price->shipping_method_id == $this->shipping_method_id)
        {
            $session  = JFactory::getSession ();

            $client   = new BaikalsrClient ();
            $cartData = $this->cartData ();
			
            if (isset ($_SESSION ['baikalsr__shipping_data'])) 
            {
                if(isset($_SESSION ['baikalsr__shipping_data']["city"]) && !empty($_SESSION ['baikalsr__shipping_data']["city"]))
					$cartData ["cityGuid"] = $_SESSION ['baikalsr__shipping_data']["city"];
            }
			
			if(empty($cartData ["city"]) && empty($cartData ["cityGuid"])){
				$cartData ["cityGuid"] = "0c5b2444-70a0-4932-980c-b4dc0d3f02b5";
				$cartData ["city"] = "Москва";
			}elseif(!empty($cartData ["city"]) && empty($cartData ["cityGuid"])){
				$cartData ["cityGuid"] = $client->getCityByName($cartData ['city']) [0]['guid'];
				if(empty($cartData ["cityGuid"])){
					$cartData ["cityGuid"] = "0c5b2444-70a0-4932-980c-b4dc0d3f02b5";
					$cartData ["city"] = "Москва";
				}
			}
			
            $shipping_price = $client->calculateOrder ($cartData);

            $session->set ('shipping_price', $shipping_price);
            $session->set ('cartData', $cartData);
            
            return (isset ($_SESSION ['baikalsr__shipping_data']))    
                ? $_SESSION ['baikalsr__shipping_data']['price']['total']
                : $shipping_price ['total'] ;
        }
        else
        {
            return $price;
        }
    }

    public function onBeforeEditOrders (&$view)
    {
    }
}

?>